package org.dbgen;

import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.dbgen.view.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class DbGenPro extends JApplet implements ActionListener {

  public static MainWindow mainWindow = null;
  public static Hashtable options = null;
  public static int level = 2;

  public static final String PROJECTS_FILENAME = "projects.dat";

  public static final String JDBC_DRIVER = "JdbcDriver";
  public static final String JDBC_URL = "JdbcUrl";
  public static final String JDBC_USERNAME = "JdbcUsername";
  public static final String JDBC_PASSWORD = "JdbcPassword";

  //	public static final String GENERATE_DATA_CLASS = "GenerateDataClass";
  //	public static final String GENERATE_TEST_CLASS = "GenerateTestClass";
  //	public static final String GENERATE_SQL_SCRIPT = "GenerateSQLScript";

  //	public static final String GENERATE_TABLE_MODEL = "GenerateTableModel";
  //	public static final String GENERATE_TABLE_MODEL_JAVAX = "GenerateTableModelJavax";


  /**
   * This method was created by a SmartGuide.
   * @param event java.awt.event.ActionEvent
   */
  public void actionPerformed(ActionEvent event) {
    if (mainWindow == null)
    {
      startApplet();
    }

    mainWindow.show();

    return;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public static boolean check(java.applet.Applet applet) {

    /* Month is 0-based, 3 means April */
    GregorianCalendar cal1 = new GregorianCalendar(1999, 5, 30);    // 19990530
    GregorianCalendar cal2 = new GregorianCalendar(1999, 5, 15);    // 19990515
    GregorianCalendar now = new GregorianCalendar();
    SimpleDateFormat sdf = new SimpleDateFormat();

    if (now.after(cal2))
    {
      System.err.println("Sorry, this beta version has been expired as of " + sdf.format(cal2.getTime()));

      return false;
    }
    else if (now.after(cal1))
    {
      System.err.println("INFO: This beta version will expire on " + sdf.format(cal1.getTime()));

      return true;
    }

    return true;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.lang.String
   */
  public static String getFullName() {
    return "DbGen v" + DbGen.VERSION;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.lang.Object
   * @param key java.lang.String
   */
  public static Object getValue(String key) {
    return options.get(key);
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void init() {

    /* We need to make sure the applet won't run after expiration also. */
    if (!check(this))
    {
      JOptionPane.showMessageDialog(this, "This demo applet has expired.", "Error Message", JOptionPane.ERROR_MESSAGE);

      return;
    }

    JButton button = new JButton("Run Demo Applet");
    button.addActionListener(this);

    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(BorderLayout.CENTER, button);

    //JOptionPane.showMessageDialog(this, "Welcome to DbGen Professional Edition Demo.\nThis is fully functional except that it cannot save project data.", "Welcome Message", JOptionPane.INFORMATION_MESSAGE);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   * @param code java.lang.String
   */
  protected static boolean isValidSerialNo(String code) {

    try {
      int len = code.length();

      //System.out.println("code length = " + len);
      if (len == 12) {
        int a = Integer.parseInt(code.substring(0, 4));
        int b = Integer.parseInt(code.substring(4, 8));
        int c = Integer.parseInt(code.substring(8, 12));

        //System.out.println(a + " + " + b + " + " + c + " = " + (a+b+c));
        return (a + b + c == 8888);
      }
    }
    catch (Throwable t)
    {
      //t.printStackTrace();
    }

    return false;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public static void loadData() {

    try {
      FileInputStream f = new FileInputStream(mainWindow.getProjectFileName());
      ObjectInputStream s = new ObjectInputStream(f);
      mainWindow.setWorkbench((Workbench) s.readObject());
      options = (Hashtable) s.readObject();
      s.close();
    } catch (Throwable t) {
      t.printStackTrace();
      System.err.println("No projects.dat file, a new workbench will be created.");
      mainWindow.setWorkbench(new Workbench());
      options = new Hashtable();
    }

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param args java.lang.String[]
   */
  public static void main(String args[]) {

    /*
     if (!check(null)) {
     JOptionPane.showMessageDialog(null, "Sorry, this beta version has expired.", "Error Message", JOptionPane.ERROR_MESSAGE);
     System.exit(0);
     }
     */

    /* Check properties */

    //	System.out.println( UIManager.getDefaults());
    //	for (Enumeration e=UIManager.getDefaults();
    try
    {
      String debug = System.getProperty("debug");

      if (debug != null && (debug.equalsIgnoreCase("true") || debug.equalsIgnoreCase("on") || debug.equals("1")))
      {
        Debug.on = true;
      }
    }
    catch (Throwable exception)
    {
      //exception.printStackTrace();
    }

    /* Create window now */
    mainWindow = new MainWindow();
    mainWindow.setTitle(getFullName());

    /* Load data from projects file */
    String filename = (args.length > 0) ? args[0] : PROJECTS_FILENAME;
    mainWindow.setProjectFileName(filename);
    loadData();

    mainWindow.show();
    mainWindow.showTips();

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param key java.lang.String
   * @param value java.lang.Object
   */
  public static void putValue(String key, Object value) {
    options.put(key, value);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public static void saveData() {

    if (mainWindow.getIsApplet())
    {
      JOptionPane.showMessageDialog(mainWindow, "You cannot save from a demo applet.", "Error Message", JOptionPane.ERROR_MESSAGE);

      return;
    }

    try {
      FileOutputStream f = new FileOutputStream(mainWindow.getProjectFileName());
      ObjectOutputStream s = new ObjectOutputStream(f);
      s.writeObject(mainWindow.getWorkbench());
      s.writeObject(options);
      s.close();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

    return;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void startApplet() {

    mainWindow = new MainWindow();
    mainWindow.setTitle(DbGen.NAME + " [DEMO]");

    try {
      String name = "http://dbgen.sourceforge.net/sample/sample.dat";
      InputStream in = (InputStream) new java.net.URL(name).openStream();
      ObjectInputStream s = new ObjectInputStream(in);
      mainWindow.setWorkbench((Workbench) s.readObject());
      options = (Hashtable) s.readObject();
      s.close();
    } catch (Throwable t) {
      t.printStackTrace();
      mainWindow.setWorkbench(new Workbench());
      options = new Hashtable();
    }

    mainWindow.setIsApplet(true);

    return;
  }
}
