package org.dbgen;

import java.sql.*;
import java.util.*;
import org.dbgen.support.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class MetaImporter implements Importer {
  protected transient java.beans.PropertyChangeSupport propertyChange = new java.beans.PropertyChangeSupport(this);
  DbAccess fieldDBA = null;
  String fieldCatalog = "";
  StringBuffer fieldLog = null;

  boolean fieldUseSchema = false;
  String fieldSchema = null;

  /**
   * This method was created by a SmartGuide.
   * @param dba org.dbgen.support.DbAccess
   */
  public MetaImporter(DbAccess dba) {
    setDBA(dba);
  }

  /**
   * This method was created by a SmartGuide.
   * @param dba DbAccess
   */
  public MetaImporter(DbAccess dba, String catalog) {
    setDBA(dba);
    setCatalog(catalog);
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.addPropertyChangeListener(listener);
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void clearLog() {
    getLog().setLength(0);

    return;
  }

  /**
   * The firePropertyChange method was generated to support the propertyChange field.
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
    propertyChange.firePropertyChange(propertyName, oldValue, newValue);
  }

  /**
   * Gets the catalog property (java.lang.String) value.
   * @return The catalog property value.
   * @see #setCatalog
   */
  public String getCatalog() {
    /* Returns the catalog property value. */
    /*
     if (fieldCatalog == null) {
     try {
     fieldCatalog = new String();
     } catch (Throwable exception) {
     System.err.println("Exception creating catalog property.");
     }
     };
     */
    return fieldCatalog;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.lang.String[]
   */
  public String[] getCatalogNames() {

    try
    {
      DatabaseMetaData md = getDBA().getConnection().getMetaData();
      Vector catalogs = new Vector();

      try
      {
        ResultSet rs = md.getCatalogs();

        while (rs.next())
        {
          catalogs.addElement(rs.getString(1));
        }

        rs.close();
      }
      catch (SQLException exp1)
      {
        exp1.printStackTrace();
      }

      /* If we can't get catalog names from getCatalog() method, try the
       * getSchemas() instead and set the property useSchema to true.
       */
      if (catalogs.size() == 0)
      {
        try
        {
          ResultSet rs = md.getSchemas();

          while (rs.next())
          {
            catalogs.addElement(rs.getString(1));
          }

          rs.close();
        }
        catch (SQLException exp2)
        {
          exp2.printStackTrace();
        }

        setUseSchema(true);
      }
      else
      {
        setUseSchema(false);
      }

      return org.dbgen.Util.convertVectorToStringArray(catalogs);
    }
    catch (SQLException exception)
    {
      exception.printStackTrace();
    }

    return null;
  }

  /**
   * Gets the DBA property (org.dbgen.support.DbAccess) value.
   * @return The DBA property value.
   * @see #setDBA
   */
  public DbAccess getDBA() {
    /* Returns the DBA property value. */
    if (fieldDBA == null) {
      try {
        fieldDBA = new DbAccess();
      } catch (Throwable exception) {
        System.err.println("Exception creating DBA property.");
      }
    };

    return fieldDBA;
  }

  /**
   * Gets the log property (java.lang.StringBuffer) value.
   * @return The log property value.
   * @see #setLog
   */
  public StringBuffer getLog() {
    /* Returns the log property value. */
    if (fieldLog == null) {
      try {
        fieldLog = new StringBuffer(2048);
      } catch (Throwable exception) {
        System.err.println("Exception creating log property.");
      }
    };

    return fieldLog;
  }

  /**
   * Gets the schema property (java.lang.String) value.
   * @return The schema property value.
   * @see #setSchema
   */
  public String getSchema() {
    /* Returns the schema property value. */
    /*
     if (fieldSchema == null) {
     try {
     fieldSchema = new String();
     } catch (Throwable exception) {
     System.err.println("Exception creating schema property.");
     }
     };
     */
    return fieldSchema;
  }

  /**
   * getTable method comment.
   */
  public Table getTable(String tableName)
  {
    try
    {
      DatabaseMetaData md = getDBA().getConnection().getMetaData();
      ResultSet rs;

      /* Get column properties */
      rs = md.getColumns(getCatalog(), null, tableName, null);
      Table table = new Table(tableName);

      while (rs.next())
      {
        String columnName = rs.getString(4);
        int type = rs.getInt(5);
        String typeName = rs.getString(6);
        int length = rs.getInt(7);
        int scale = rs.getInt(9);

        if (!isStandardSQLType(type))
        {
          type = guessSQLType(typeName);
        }

        table.addField(new Field(false, columnName, type, length, scale));
      }

      rs.close();

      /* Get primary keys */
      try
      {
        rs = md.getPrimaryKeys(getCatalog(), null, tableName);
        int numKeys = 0;

        while (rs.next())
        {
          Field field = table.findField(rs.getString(4));

          if (field != null)
          {
            field.setIsKey(true);
            numKeys++;
          }
        }

        if (numKeys == 0)
        {
          getLog().append("There are no key fields for table " + getCatalog() + ":" + tableName + "\n");
        }
      }
      catch (SQLException e1)
      {
        getLog().append("Cannot get primary keys for " + getCatalog() + ":" + tableName + "\n");
        getLog().append(" " + e1.getMessage() + "\n");

        //			System.err.println("Cannot get primary keys " + e1.toString());
      }

      return table;
    }
    catch (SQLException e2)
    {
      getLog().append("Cannot import table " + getCatalog() + ":" + tableName + "\n");
      getLog().append(" " + e2.getMessage() + "\n");
    }

    return null;
  }

  /**
   * getTableNames method comment.
   */
  public java.lang.String[] getTableNames() {

    try
    {
      /* Read table names from database */
      System.out.println("Catalog = " + getCatalog() + ", Schema = " + getSchema());
      DatabaseMetaData md = getDBA().getConnection().getMetaData();
      ResultSet rs = md.getTables(getCatalog(), getSchema(), null, new String[] { "TABLE" });
      Vector vec = new Vector();

      while (rs.next())
      {
        //	  		System.out.println("Table: " + rs.getString(3));
        vec.addElement(rs.getString(3));
      }

      rs.close();

      return org.dbgen.Util.convertVectorToStringArray(vec);
    }
    catch (SQLException exception)
    {
      getLog().append("Cannot get table names for " + getCatalog() + "\n");
      getLog().append(" " + exception.getMessage() + "\n");
    }

    return null;
  }

  /**
   * Gets the useSchema property (boolean) value.
   * @return The useSchema property value.
   * @see #setUseSchema
   */
  public boolean getUseSchema() {
    /* Returns the useSchema property value. */
    return fieldUseSchema;
  }

  /**
   * This method was created by a SmartGuide.
   * @return int
   * @param typeName java.lang.String
   */
  protected int guessSQLType(String typeName) {

    String name = typeName.toLowerCase();
    boolean date = false;
    boolean time = false;

    if (name.indexOf("date") >= 0)
      date = true;

    if (name.indexOf("time") >= 0)
      time = true;

    if (date && time)
      return java.sql.Types.TIMESTAMP;
    else if (date)
      return java.sql.Types.DATE;
    else if (time)
      return java.sql.Types.TIME;
    else
      return java.sql.Types.OTHER;
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   */
  public boolean isEmptyLog() {
    return (getLog().length() == 0);
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   * @param type int
   */
  protected boolean isStandardSQLType(int type) {
    return FieldTypes.id2string(type) != null;
  }

  /**
   * The removePropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.removePropertyChangeListener(listener);
  }

  /**
   * Sets the catalog property (java.lang.String) value.
   * @param catalog The new value for the property.
   * @see #getCatalog
   */
  public void setCatalog(String catalog) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldCatalog;

    /* Set the catalog property (attribute) to the new value. */
    fieldCatalog = catalog;

    /* Fire (signal/notify) the catalog property change event. */
    firePropertyChange("catalog", oldValue, catalog);

    return;
  }

  /**
   * Sets the DBA property (org.dbgen.support.DbAccess) value.
   * @param DBA The new value for the property.
   * @see #getDBA
   */
  public void setDBA(DbAccess DBA) {
    /* Get the old property value for fire property change event. */
    DbAccess oldValue = fieldDBA;

    /* Set the DBA property (attribute) to the new value. */
    fieldDBA = DBA;

    /* Fire (signal/notify) the DBA property change event. */
    firePropertyChange("DBA", oldValue, DBA);

    return;
  }

  /**
   * Sets the log property (java.lang.StringBuffer) value.
   * @param log The new value for the property.
   * @see #getLog
   */
  public void setLog(StringBuffer log) {
    fieldLog = log;

    return;
  }

  /**
   * Sets the schema property (java.lang.String) value.
   * @param schema The new value for the property.
   * @see #getSchema
   */
  public void setSchema(String schema) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldSchema;

    /* Set the schema property (attribute) to the new value. */
    fieldSchema = schema;

    /* Fire (signal/notify) the schema property change event. */
    firePropertyChange("schema", oldValue, schema);

    return;
  }

  /**
   * Sets the useSchema property (boolean) value.
   * @param useSchema The new value for the property.
   * @see #getUseSchema
   */
  public void setUseSchema(boolean useSchema) {
    /* Get the old property value for fire property change event. */
    boolean oldValue = fieldUseSchema;

    /* Set the useSchema property (attribute) to the new value. */
    fieldUseSchema = useSchema;

    /* Fire (signal/notify) the useSchema property change event. */
    firePropertyChange("useSchema", new Boolean(oldValue), new Boolean(useSchema));

    return;
  }

  /**
   * TESTING
   * @param args java.lang.String[]
   */
  public static void test(String args[]) {

    try
    {
      String drv = "sun.jdbc.odbc.JdbcOdbcDriver";
      String url = "jdbc:odbc:DSJobLink";
      DbAccess dba = new DbAccess(drv, url, "", "");
      MetaImporter importer = new MetaImporter(dba, "DSJobLink");

      String[] catalogNames = importer.getCatalogNames();

      for (int i = 0; i < catalogNames.length; i++) {
        org.dbgen.Debug.println("Catalog " + (i+1) + ": " + catalogNames[i]);
      }

      importer.setCatalog(catalogNames[0]);
      String[] tableNames = importer.getTableNames();

      for (int i = 0; i < tableNames.length; i++) {
        org.dbgen.Debug.println("Table " + (i+1) + ": " + tableNames[i]);
      }

      Table table = importer.getTable(args[0]);
      table.dump();
    }
    catch (Throwable exception)
    {
      exception.printStackTrace();
    }

    return;
  }
}
