package org.dbgen;

import java.util.*;
import org.dbgen.event.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class Project implements java.io.Serializable {
  java.util.Vector fieldTables = null;
  protected transient java.beans.PropertyChangeSupport propertyChange = new java.beans.PropertyChangeSupport(this);;
  protected transient java.util.Vector aTableChangedListener = null;
  String fieldProjectName = "";
  String fieldDefaultPackageName = "";
  String fieldOutputDirectory = "";
  int fieldTargetDatabase = 0;

  // Serialized version
  public static final long serialVersionUID = 1002;


  /**
   * This method was created by a SmartGuide.
   */
  public Project ( ) {
  }

  /**
   * This method was created by a SmartGuide.
   * @param projectName java.lang.String
   */
  public Project(String projectName) {
    setProjectName(projectName);
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {

    if (propertyChange == null)
      propertyChange = new java.beans.PropertyChangeSupport(this);

    propertyChange.addPropertyChangeListener(listener);
  }

  /**
   * Performs the addTable method.
   * @param table org.dbgen.Table
   */
  public void addTable(Table table) {

    Vector tables = getTables();
    int i;

    for (i = 0; i < tables.size(); i++)
    {
      Table against = (Table) tables.elementAt(i);

      if (table.toString().compareTo(against.toString()) < 0)
      {
      break;
      }
    }

    tables.insertElementAt(table, i);
    table.setProject(this);

    fireTableAdded(new TableAddedEvent(this, table));

    return;
  }

  /**
   * Add a org.dbgen.TableChangedListener.
   */
  public void addTableChangedListener(TableChangedListener newListener) {
    if (aTableChangedListener == null) {
      aTableChangedListener = new java.util.Vector();
    };

    aTableChangedListener.addElement(newListener);
  }

  /**
   * Performs the deleteTable method.
   * @param table org.dbgen.Table
   */
  public void deleteTable(Table table) {
    /* Perform the deleteTable method. */
    Debug.println("Removing table " + table);
    getTables().removeElement(table);
    Debug.println("Notifying TableDelete Listeners...");
    fireTableDeleted(new TableDeletedEvent(this, table));
    Debug.println("Done");

    return;
  }

  /**
   * This method was created in VisualAge.
   * @return org.dbgen.Table
   * @param name java.lang.String
   */
  public Table findTableByName( String name ) {
    Vector tables = getTables();

    for ( int i=0; i<tables.size(); i++ ) {
      if ( ((Table) tables.elementAt(i)).getTableName().equals(name))
        return (Table) tables.elementAt(i);
    }

    return null;
  }

  /**
   * The firePropertyChange method was generated to support the propertyChange field.
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
    propertyChange.firePropertyChange(propertyName, oldValue, newValue);
  }

  /**
   * Method to support listener events.
   */
  protected void fireTableAdded(TableAddedEvent e) {
    if (aTableChangedListener == null) {
      return;
    };

    int currentSize = aTableChangedListener.size();
    TableChangedListener tempListener = null;

    for (int index = 0; index < currentSize; index++){
      tempListener = (TableChangedListener)aTableChangedListener.elementAt(index);

      if (tempListener != null) {
        tempListener.tableAdded(e);
      };
    };
  }

  /**
   * Method to support listener events.
   */
  protected void fireTableDeleted(TableDeletedEvent e) {
    if (aTableChangedListener == null) {
      return;
    };

    int currentSize = aTableChangedListener.size();
    TableChangedListener tempListener = null;

    for (int index = 0; index < currentSize; index++){
      tempListener = (TableChangedListener)aTableChangedListener.elementAt(index);

      if (tempListener != null) {
        Debug.println(" sending TableDelete signal to " + tempListener);
        tempListener.tableDeleted(e);
      };
    };
  }

  /**
   * Gets the defaultPackageName property (java.lang.String) value.
   * @return The defaultPackageName property value.
   * @see #setDefaultPackageName
   */
  public String getDefaultPackageName() {
    /* Returns the defaultPackageName property value. */
    if (fieldDefaultPackageName == null) {
      try {
        fieldDefaultPackageName = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating defaultPackageName property.");
      }
    };

    return fieldDefaultPackageName;
  }

  /**
   * Gets the outputDirectory property (java.lang.String) value.
   * @return The outputDirectory property value.
   * @see #setOutputDirectory
   */
  public String getOutputDirectory() {
    /* Returns the outputDirectory property value. */
    if (fieldOutputDirectory == null) {
      try {
        fieldOutputDirectory = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating outputDirectory property.");
      }
    };

    return fieldOutputDirectory;
  }

  /**
   * Gets the projectName property (java.lang.String) value.
   * @return The projectName property value.
   * @see #setProjectName
   */
  public String getProjectName() {
    /* Returns the projectName property value. */
    if (fieldProjectName == null) {
      try {
        fieldProjectName = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating projectName property.");
      }
    };

    return fieldProjectName;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.util.Vector
   */
  public java.util.Vector getReadyTables() {

    java.util.Vector readyTables = new java.util.Vector();
    java.util.Vector tables = getTables();

    for (int i = 0; i < tables.size(); i++)
    {
      Table obj = (Table) tables.elementAt(i);

      if (obj.isReadyForGeneration( new Vector()))
      {
        readyTables.addElement(obj);
      }
    }

    return readyTables;
  }

  /**
   * This method was created in VisualAge.
   * @return java.util.Vector
   * @param table org.dbgen.Table
   */
  public Vector getRelationsByForeignTable( String foreignTableName ) {
    // Raymond 11/19/98
    // check all relations in every table for this foreign table
    Vector tableList = getTables();
    Vector result = new Vector();
    Table table = null;

    for ( int i=0; i<tableList.size(); i++ ) {
      table = (Table) tableList.elementAt(i);

      Vector relas = table.getRelations();
      Relation r = null;

      for ( int j=0; j<relas.size(); j++ ) {
        r = (Relation) relas.elementAt(j);

        if ( foreignTableName.
          equals(r.getForeignTable().getTableName()) )
        {
          result.addElement(r);
        }
      }
    }

    // should be catagorized by master table
    return result;
  }

  /**
   * Gets the tables property (java.util.Vector) value.
   * @return The tables property value.
   * @see #setTables
   */
  public java.util.Vector getTables() {
    /* Returns the tables property value. */
    if (fieldTables == null) {
      try {
        fieldTables = new java.util.Vector();
      } catch (Throwable exception) {
        System.err.println("Exception creating tables property.");
      }
    };

    return fieldTables;
  }

  /**
   * Gets the targetDatabase property (int) value.
   * @return The targetDatabase property value.
   * @see #setTargetDatabase
   */
  public int getTargetDatabase() {
    /* Returns the targetDatabase property value. */
    return fieldTargetDatabase;
  }

  /**
   * The removePropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.removePropertyChangeListener(listener);
  }

  /**
   * Remove a org.dbgen.TableChangedListener.
   */
  public void removeTableChangedListener(TableChangedListener newListener) {
    if (aTableChangedListener != null) {
      aTableChangedListener.removeElement(newListener);
    };
  }

  /**
   * Sets the defaultPackageName property (java.lang.String) value.
   * @param defaultPackageName The new value for the property.
   * @see #getDefaultPackageName
   */
  public void setDefaultPackageName(String defaultPackageName) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldDefaultPackageName;

    /* Set the defaultPackageName property (attribute) to the new value. */
    fieldDefaultPackageName = defaultPackageName;

    /* Fire (signal/notify) the defaultPackageName property change event. */
    firePropertyChange("defaultPackageName", oldValue, defaultPackageName);

    return;
  }

  /**
   * Sets the outputDirectory property (java.lang.String) value.
   * @param outputDirectory The new value for the property.
   * @see #getOutputDirectory
   */
  public void setOutputDirectory(String outputDirectory) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldOutputDirectory;

    /* Set the outputDirectory property (attribute) to the new value. */
    fieldOutputDirectory = outputDirectory;

    /* Fire (signal/notify) the outputDirectory property change event. */
    firePropertyChange("outputDirectory", oldValue, outputDirectory);

    return;
  }

  /**
   * Sets the projectName property (java.lang.String) value.
   * @param projectName The new value for the property.
   * @see #getProjectName
   */
  public void setProjectName(String projectName) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldProjectName;

    /* Set the projectName property (attribute) to the new value. */
    fieldProjectName = projectName;

    /* Fire (signal/notify) the projectName property change event. */
    firePropertyChange("projectName", oldValue, projectName);

    return;
  }

  /**
   * Sets the tables property (java.util.Vector) value.
   * @param tables The new value for the property.
   * @see #getTables
   */
  public void setTables(java.util.Vector tables) {
    /* Get the old property value for fire property change event. */
    java.util.Vector oldValue = fieldTables;

    /* Set the tables property (attribute) to the new value. */
    fieldTables = tables;

    /* Fire (signal/notify) the tables property change event. */
    firePropertyChange("tables", oldValue, tables);

    return;
  }

  /**
   * Sets the targetDatabase property (int) value.
   * @param targetDatabase The new value for the property.
   * @see #getTargetDatabase
   */
  public void setTargetDatabase(int targetDatabase) {
    /* Get the old property value for fire property change event. */
    int oldValue = fieldTargetDatabase;

    /* Set the targetDatabase property (attribute) to the new value. */
    fieldTargetDatabase = targetDatabase;

    /* Fire (signal/notify) the targetDatabase property change event. */
    firePropertyChange("targetDatabase", new Integer(oldValue), new Integer(targetDatabase));

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.lang.String
   */
  public String toString() {
    return getProjectName();
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.lang.String
   */
  public String toStringRep() {
    return "#(" + getProjectName() + " " + getDefaultPackageName() + " " + getOutputDirectory() + ")";
  }
}
