package org.dbgen;

import java.util.*;
import org.dbgen.support.*;

/**
 * A Relation contains two Data classes - a parent and a child.
 * The relationship can be 1-to-1 or 1-to-N.
 */
public class Relation implements java.io.Serializable {
  protected transient java.beans.PropertyChangeSupport propertyChange = new java.beans.PropertyChangeSupport(this);
  java.util.Vector fieldKeyMap = null;

  // Serialized version
  public static final long serialVersionUID = 1002;

  private Table fieldMasterTable = new Table();
  private Table fieldForeignTable = new Table();
  private Field fieldForeignKey = new Field();
  private Field fieldMasterKey = new Field();

  /**
   * This method was created by a SmartGuide.
   */
  public Relation ( ) {
  }

  /**
   * This method was created by a SmartGuide.
   * @param parent Table
   * @param child Table
   */
  public Relation(Table master) {

    setMasterTable(master);
  }

  /**
   * This method was created by a SmartGuide.
   * @param parent Table
   * @param child Table
   */
  public Relation(Table masterTable, Table foreignTable, Field masterKey, Field foreignKey) {

    setMasterTable(masterTable);
    setForeignTable(foreignTable);
    setMasterKey(masterKey);
    setForeignKey(foreignKey);
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.addPropertyChangeListener(listener);
  }

  /**
   * The firePropertyChange method was generated to support the propertyChange field.
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue)
  {
    if (propertyChange != null)
      propertyChange.firePropertyChange(propertyName, oldValue, newValue);
  }

  /**
   * Gets the foreignKey property (org.dbgen.Field) value.
   * @return The foreignKey property value.
   * @see #setForeignKey
   */
  public Field getForeignKey() {
    return fieldForeignKey;
  }

  /**
   * Gets the foreignTable property (org.dbgen.Table) value.
   * @return The foreignTable property value.
   * @see #setForeignTable
   */
  public Table getForeignTable() {
    return fieldForeignTable;
  }

  /**
   * Gets the masterKey property (org.dbgen.Field) value.
   * @return The masterKey property value.
   * @see #setMasterKey
   */
  public Field getMasterKey() {
    return fieldMasterKey;
  }

  /**
   * Gets the masterTable property (org.dbgen.Table) value.
   * @return The masterTable property value.
   * @see #setMasterTable
   */
  public Table getMasterTable() {
    return fieldMasterTable;
  }

  /**
   * The removePropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.removePropertyChangeListener(listener);
  }

  /**
   * Sets the foreignKey property (org.dbgen.Field) value.
   * @param foreignKey The new value for the property.
   * @see #getForeignKey
   */
  public void setForeignKey(Field foreignKey) {
    Field oldValue = fieldForeignKey;
    fieldForeignKey = foreignKey;
    firePropertyChange("foreignKey", oldValue, foreignKey);
  }

  /**
   * Sets the foreignTable property (org.dbgen.Table) value.
   * @param foreignTable The new value for the property.
   * @see #getForeignTable
   */
  public void setForeignTable(Table foreignTable) {
    Table oldValue = fieldForeignTable;
    fieldForeignTable = foreignTable;
    firePropertyChange("foreignTable", oldValue, foreignTable);
  }

  /**
   * Sets the masterKey property (org.dbgen.Field) value.
   * @param masterKey The new value for the property.
   * @see #getMasterKey
   */
  public void setMasterKey(Field masterKey) {
    Field oldValue = fieldMasterKey;
    fieldMasterKey = masterKey;
    firePropertyChange("masterKey", oldValue, masterKey);
  }

  /**
   * Sets the masterTable property (org.dbgen.Table) value.
   * @param masterTable The new value for the property.
   * @see #getMasterTable
   */
  public void setMasterTable(Table masterTable) {
    Table oldValue = fieldMasterTable;
    fieldMasterTable = masterTable;
    firePropertyChange("masterTable", oldValue, masterTable);
  }
}
