package org.dbgen;

import java.util.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class Table implements java.io.Serializable {
  Vector fieldFields = null;
  Vector fieldRelations = null;
  protected transient java.beans.PropertyChangeSupport propertyChange = new java.beans.PropertyChangeSupport(this);;
  protected transient Vector fieldChangedListeners = new Vector();
  protected transient Vector relationChangedListeners = new Vector();
  String fieldPackageName = "";
  String fieldClassName = "";
  String fieldTableName = "";
  protected transient byte viewStyle = VIEW_TABLE_NAME;
  protected final static transient byte VIEW_TABLE_NAME = 1;
  protected final static transient byte VIEW_CLASS_NAME = 2;

  // Serialized version
  public static final long serialVersionUID = 1002;

  // Added for linking to project		Raymond	11/19/98
  private Project fieldProject = null;

  /**
   * This method was created by a SmartGuide.
   */
  public Table ( ) {
  }

  /**
   * This method was created by a SmartGuide.
   * @param tableName java.lang.String
   */
  public Table(String tableName) {
    setTableName(tableName);
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void addDefaultField() {
    int i = 1;
    String name;

    while (true)
    {
      name = "Field" + i;

      if (!fieldExists(name))
      break;
      i++;
    }

    addField(new Field(false, name, java.sql.Types.VARCHAR, 1, 0));
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void addDefaultRelation() {

    Relation r = new Relation(this);
    addRelation(r);
  }

  /**
   * This method was created by a SmartGuide.
   * @param field org.dbgen.Field
   */
  public void addField(Field field) {
    getFields().addElement(field);
    fireFieldChanged(field, true);

    return;
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addFieldChangedListener(org.dbgen.event.FieldChangedListener listener) {

    if (fieldChangedListeners == null)
      fieldChangedListeners = new Vector();

    fieldChangedListeners.addElement(listener);
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {

    if (propertyChange == null)
      propertyChange = new java.beans.PropertyChangeSupport(this);

    propertyChange.addPropertyChangeListener(listener);
  }

  /**
   * This method was created by a SmartGuide.
   * @param field org.dbgen.Field
   */
  public void addRelation(Relation relation) {
    getRelations().addElement(relation);
    fireRelationChanged(relation, true);

    return;
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addRelationChangedListener(org.dbgen.event.RelationChangedListener listener) {

    if (relationChangedListeners == null)
      relationChangedListeners = new Vector();

    relationChangedListeners.addElement(listener);
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   */
  public String checkReadyForGeneration( Vector ancestorTables) {

    String s = "ReadyTable: ";

    if (getTableName() == null)
    {
      org.dbgen.Debug.println(s + "No table name.");

      return "Table name is missing.";
    }

    String className = getClassName();

    if (className == null || className.length() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no class name.");

      return "Class namd for table " + getTableName() + " is missing.";
    }

    if ( !Util.isValidClassName(className))
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has invalid class name: " + className);

      return "Class namd for table " + getTableName() + " is invalid.";
    }

    Vector fields = getFields();

    if (fields == null || fields.size() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no fields.");

      return "No field in table " + getTableName() + ".";
    }

    Vector keyFields = getKeyFields();

    if (keyFields == null || keyFields.size() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no KEY fields.");

      return "No key field in table " + getTableName() + ".";
    }

    Vector relations = getRelations();
    boolean isOk = true;

    if ( relations != null ) {
      // check if this table is from the ancestor, prevent a loop
      ancestorTables.addElement(this);

      Relation r = null;

      for ( int i=0; i<relations.size(); i++ ) {
        r = (Relation) relations.elementAt(i);

        if ( r.getMasterKey() == null ) {
          org.dbgen.Debug.println(s + "Relation-MasterKey " + r.getMasterKey() + " is missing.");

          return "Relation-MasterKey " + r.getMasterKey() + " in table " + getTableName() + " is missing.";
        }

        if ( r.getForeignKey() == null ) {
          org.dbgen.Debug.println(s + "Relation-ForeignKey " + r.getForeignKey() + " is missing.");

          return "Relation-ForeignKey " + r.getForeignKey() + " in table " + getTableName() + " is missing.";
        }

        if ( r.getForeignTable() == null ) {
          org.dbgen.Debug.println(s + "Relation-ForeignTable " + r.getForeignTable() + " is missing.");

          return "Relation-ForeignTable " + r.getForeignTable() + " in table " + getTableName() + " is missing.";
        }

        if ( ancestorTables.contains(r.getForeignTable()) ) {
          org.dbgen.Debug.println(s + " There is a relation loop between " + getTableName() + " and " + r.getForeignTable() + ". Please correct it.");

          return "Error: A relation loop between table " + getTableName() + " and table" + r.getForeignTable() + ".";
        } else {

          return r.getForeignTable().checkReadyForGeneration(ancestorTables);
        }
      }
    }

    return "";
  }

  /**
   * This method was created by a SmartGuide.
   * @param field org.dbgen.Field
   */
  public void deleteField(Field field) {
    getFields().removeElement(field);
    fireFieldChanged(field, false);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param field org.dbgen.Field
   */
  public void deleteRelation(Relation relation) {
    getRelations().removeElement(relation);
    fireRelationChanged(relation, false);

    return;
  }

  /**
   * DEBUG
   */
  public void dump() {

    org.dbgen.Debug.println("** Dumping Table " + getTableName() + " **");
    org.dbgen.Debug.println("Class Name = " + getClassName());
    org.dbgen.Debug.println("Package Name = " + getPackageName());

    for (int i = 0; i < getFields().size(); i++)
    {
      Field field = (Field) getFields().elementAt(i);
      org.dbgen.Debug.println((i+1) + ". " + (field.getIsKey() ? "<Key> " : "") + field.getName() + ", " +
        FieldTypes.id2string(field.getType()) + ", " + field.getLength() + ", " + field.getScale());
    }

    for (int i = 0; i < getRelations().size(); i++)
    {
      Relation relation = (Relation) getRelations().elementAt(i);
      org.dbgen.Debug.println
        ((i+1) + ". Master: " +
          relation.getMasterTable() + " : " +
          relation.getMasterKey() + ", Foreign: " +
          relation.getForeignTable() + " : " +
          relation.getForeignKey() );
    }


    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   * @param name java.lang.String
   */
  protected boolean fieldExists(String name) {
    Vector fields = getFields();

    for (int i = 0; i < fields.size(); i++)
    {
      Field field = (Field) fields.elementAt(i);

      if (field.getName().equals(name))
        return true;
    }

    return false;
  }

  /**
   * This method was created by a SmartGuide.
   * @return org.dbgen.Field
   * @param fieldName java.lang.String
   */
  public Field findField(String fieldName) {

    Vector fields = getFields();

    for (int i = 0; i < fields.size(); i++)
    {
      Field f = (Field) fields.elementAt(i);

      if (f.getName().equals(fieldName))
        return f;
    }

    return null;
  }

  /**
   * This method was created by a SmartGuide.
   * @return org.dbgen.Field
   * @param fieldName java.lang.String
   */
  public Vector findRelation(String foreignTableName) {

    Vector result = new Vector();
    Vector relations = getRelations();

    for (int i = 0; i < relations.size(); i++)
    {
      Relation r = (Relation) relations.elementAt(i);

      if (r.getForeignTable().equals(foreignTableName))
        result.addElement(r);
    }

    return result;
  }

  /**
   * Fire a tableChangedEvent to listeners.
   */
  public void fireFieldChanged(Field field, boolean added) {

    Vector l;
    EventObject event = added ? (EventObject) new org.dbgen.event.FieldAddedEvent(field) : (EventObject) new org.dbgen.event.FieldDeletedEvent(field);

    synchronized (this) {
      l = (Vector) fieldChangedListeners.clone();
    }

    for (int i = 0; i < l.size(); i++)
    {
      org.dbgen.event.FieldChangedListener listener = (org.dbgen.event.FieldChangedListener) l.elementAt(i);

      if (added)
      {
        listener.fieldAdded((org.dbgen.event.FieldAddedEvent) event);
      }
      else
      {
        listener.fieldDeleted((org.dbgen.event.FieldDeletedEvent) event);
      }
    }
  }

  /**
   * The firePropertyChange method was generated to support the propertyChange field.
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
    propertyChange.firePropertyChange(propertyName, oldValue, newValue);
  }

  /**
   * Fire a tableChangedEvent to listeners.
   */
  public void fireRelationChanged(Relation relation, boolean added) {

    Vector l;
    EventObject event = added ? (EventObject) new org.dbgen.event.RelationAddedEvent(relation) : (EventObject) new org.dbgen.event.RelationDeletedEvent(relation);

    synchronized (this) {
      l = (Vector) relationChangedListeners.clone();
    }

    for (int i = 0; i < l.size(); i++)
    {
      org.dbgen.event.RelationChangedListener listener = (org.dbgen.event.RelationChangedListener) l.elementAt(i);

      if (added)
      {
        listener.relationAdded((org.dbgen.event.RelationAddedEvent) event);
      }
      else
      {
        listener.relationDeleted((org.dbgen.event.RelationDeletedEvent) event);
      }
    }
  }

  /**
   * Gets the className property (java.lang.String) value.
   * @return The className property value.
   * @see #setClassName
   */
  public String getClassName() {
    /* Returns the className property value. */
    if (fieldClassName == null) {
      try {
        fieldClassName = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating className property.");
      }
    };

    return fieldClassName;
  }

  /**
   * Performs the getField method.
   * @return org.dbgen.Field
   * @param index int
   */
  public Field getField(int index) {
    /* Perform the getField method. */
    return (Field) getFields().elementAt(index);
  }

  /**
   * Gets the fields property (java.util.Vector) value.
   * @return The fields property value.
   * @see #setFields
   */
  public Vector getFields() {
    /* Returns the fields property value. */
    if (fieldFields == null) {
      try {
        fieldFields = new Vector();
      } catch (Throwable exception) {
        System.err.println("Exception creating fields property.");
      }
    };

    return fieldFields;
  }

  /**
   * This method was created in VisualAge.
   * @return java.util.Vector
   */
  public Vector getForeignTables( ) {
    Vector result = (Vector) getProject().getTables().clone();
    result.removeElement(this);

    return result;
  }

  /**
   * This method was created in VisualAge.
   */
  public Vector getForeignTablesWithRelation() {
    Vector result = new Vector();
    Vector relations = getRelations();
    Relation r = null;

    for ( int i=0; i<relations.size(); i++ ) {
      r = (Relation) relations.elementAt(i);

      // prevent duplication
      result.removeElement( r.getForeignTable() );
      result.addElement( r.getForeignTable() );
    }

    return result;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.util.Vector
   */
  public Vector getKeyFields() {

    Vector result = new Vector();
    Vector fields = getFields();

    for (int i = 0; i < fields.size(); i++)
    {
      Field f = (Field) fields.elementAt(i);

      if (f.getIsKey())
      {
        result.addElement(f);
      }
    }

    return result.size() > 0 ? result : null;
  }

  /**
   * Gets the packageName property (java.lang.String) value.
   * @return The packageName property value.
   * @see #setPackageName
   */
  public String getPackageName() {
    /* Returns the packageName property value. */
    if (fieldPackageName == null) {
      try {
        fieldPackageName = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating packageName property.");
      }
    };

    return fieldPackageName;
  }

  /**
   * Gets the project property (org.dbgen.Project) value.
   * @return The project property value.
   * @see #setProject
   */
  public Project getProject() {
    return fieldProject;
  }

  /**
   * Performs the getField method.
   * @return org.dbgen.Field
   * @param index int
   */
  public Relation getRelation(int index) {
    /* Perform the getField method. */
    return (Relation) getRelations().elementAt(index);
  }

  /**
   * Gets the fields property (java.util.Vector) value.
   * @return The fields property value.
   * @see #setFields
   */
  public Vector getRelations() {
    /* Returns the fields property value. */
    if (fieldRelations == null) {
      try {
        fieldRelations = new Vector();
      } catch (Throwable exception) {
        System.err.println("Exception creating relations property.");
      }
    };

    return fieldRelations;
  }

  /**
   * Gets the tableName property (java.lang.String) value.
   * @return The tableName property value.
   * @see #setTableName
   */
  public String getTableName() {
    /* Returns the tableName property value. */
    if (fieldTableName == null) {
      try {
        fieldTableName = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating tableName property.");
      }
    };

    return fieldTableName;
  }

  /**
   * This method was created by a SmartGuide.
   * @return boolean
   */
  public boolean isReadyForGeneration( Vector ancestorTables) {

    String s = "ReadyTable: ";

    if (getTableName() == null)
    {
      org.dbgen.Debug.println(s + "No table name.");

      return false;
    }

    String className = getClassName();

    if (className == null || className.length() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no class name.");

      return false;
    }

    if ( !Util.isValidClassName(className))
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has invalid class name: " + className);

      return false;
    }

    Vector fields = getFields();

    if (fields == null || fields.size() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no fields.");

      return false;
    }

    Vector keyFields = getKeyFields();

    if (keyFields == null || keyFields.size() == 0)
    {
      org.dbgen.Debug.println(s + "Table " + getTableName() + " has no KEY fields.");

      return false;
    }

    Vector relations = getRelations();
    boolean isOk = true;

    if ( relations != null ) {
      // check if this table is from the ancestor, prevent a loop
      ancestorTables.addElement(this);

      Relation r = null;

      for ( int i=0; i<relations.size(); i++ ) {
        r = (Relation) relations.elementAt(i);

        if ( r.getMasterKey() == null ) {
          org.dbgen.Debug.println(s + "Relation-MasterKey " + r.getMasterKey() + " is missing.");
          isOk = false;
        }

        if ( r.getForeignTable() == null ) {
          org.dbgen.Debug.println(s + "Relation-ForeignTable " + r.getForeignTable() + " is missing.");
          isOk = false;
        } else {

          if ( ancestorTables.contains(r.getForeignTable()) ) {
            org.dbgen.Debug.println(s + " There is a relation loop between " + getTableName() + " and " + r.getForeignTable() + ". Please correct it.");
            isOk = false;
          } else {

            if ( !r.getForeignTable().isReadyForGeneration(ancestorTables) ) {
              isOk = false;
            }
          }
        }

        if ( r.getForeignKey() == null ) {
          org.dbgen.Debug.println(s + "Relation-ForeignKey " + r.getForeignKey() + " is missing.");
          isOk = false;
        }
      }
    }

    return isOk;
  }

  /**
   * Remove a field change listener.
   */
  public synchronized void removeFieldChangedListener(org.dbgen.event.FieldChangedListener listener) {
    fieldChangedListeners.removeElement(listener);
  }

  /**
   * The removePropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.removePropertyChangeListener(listener);
  }

  /**
   * Remove a field change listener.
   */
  public synchronized void removeRelationChangedListener(org.dbgen.event.FieldChangedListener listener) {
    fieldChangedListeners.removeElement(listener);
  }

  /**
   * Remove a field change listener.
   */
  public synchronized void removeRelationChangedListener(org.dbgen.event.RelationChangedListener listener) {
    relationChangedListeners.removeElement(listener);
  }

  /**
   * Sets the className property (java.lang.String) value.
   * @param className The new value for the property.
   * @see #getClassName
   */
  public void setClassName(String className) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldClassName;

    /* Set the className property (attribute) to the new value. */
    fieldClassName = className;

    /* Fire (signal/notify) the className property change event. */
    firePropertyChange("className", oldValue, className);

    return;
  }

  /**
   * Sets the fields property (java.util.Vector) value.
   * @param fields The new value for the property.
   * @see #getFields
   */
  public void setFields(Vector fields) {
    /* Get the old property value for fire property change event. */
    Vector oldValue = fieldFields;

    /* Set the fields property (attribute) to the new value. */
    fieldFields = fields;

    /* Fire (signal/notify) the fields property change event. */
    firePropertyChange("fields", oldValue, fields);

    return;
  }

  /**
   * Sets the packageName property (java.lang.String) value.
   * @param packageName The new value for the property.
   * @see #getPackageName
   */
  public void setPackageName(String packageName) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldPackageName;

    /* Set the packageName property (attribute) to the new value. */
    fieldPackageName = packageName;

    /* Fire (signal/notify) the packageName property change event. */
    firePropertyChange("packageName", oldValue, packageName);

    return;
  }

  /**
   * Sets the project property (org.dbgen.Project) value.
   * @param project The new value for the property.
   * @see #getProject
   */
  public void setProject(Project project) {
    Project oldValue = fieldProject;
    fieldProject = project;
    firePropertyChange("project", oldValue, project);
  }

  /**
   * Sets the fields property (java.util.Vector) value.
   * @param fields The new value for the property.
   * @see #getFields
   */
  public void setRelation(Vector relations) {
    /* Get the old property value for fire property change event. */
    Vector oldValue = fieldRelations;

    /* Set the fields property (attribute) to the new value. */
    fieldRelations = relations;

    /* Fire (signal/notify) the fields property change event. */
    firePropertyChange("fields", oldValue, relations);

    return;
  }

  /**
   * Sets the tableName property (java.lang.String) value.
   * @param tableName The new value for the property.
   * @see #getTableName
   */
  public void setTableName(String tableName) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldTableName;

    /* Set the tableName property (attribute) to the new value. */
    fieldTableName = tableName;

    /* Fire (signal/notify) the tableName property change event. */
    firePropertyChange("tableName", oldValue, tableName);

    return;
  }

  /**
   * Performs the toString method.
   * @return java.lang.String
   */
  public String toString() {
    /* Perform the toString method. */
    //	if (viewStyle == VIEW_TABLE_NAME)
    //		return getTableName();
    //	else
    //		return getClassName();

    return getTableName();
  }
}
