package org.dbgen;

/**
 * This class was generated by a SmartGuide.
 *
 */
import org.dbgen.event.*;
public class Workbench implements java.io.Serializable {
  java.util.Vector fieldProjects = null;
  protected transient java.beans.PropertyChangeSupport propertyChange = new java.beans.PropertyChangeSupport(this);
  protected transient java.util.Vector aProjectChangedListener = null;

  // Serialized version
  public static final long serialVersionUID = 1002;


  /**
   * This method was created by a SmartGuide.
   * @param project org.dbgen.Project
   */
  public synchronized void addProject(Project project) {

    java.util.Vector projects = getProjects();
    int i;

    for (i = 0; i < projects.size(); i++)
    {
      Project against = (Project) projects.elementAt(i);

      if (project.toString().compareTo(against.toString()) < 0)
      {
      break;
      }
    }

    projects.insertElementAt(project, i);

    fireProjectAdded(new ProjectAddedEvent(this, project));

    return;
  }

  /**
   * Add a org.dbgen.ProjectChangedListener.
   */
  public void addProjectChangedListener(ProjectChangedListener newListener) {
    if (aProjectChangedListener == null) {
      aProjectChangedListener = new java.util.Vector();
    };

    aProjectChangedListener.addElement(newListener);
  }

  /**
   * The addPropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.addPropertyChangeListener(listener);
  }

  /**
   * This method was created by a SmartGuide.
   * @param project org.dbgen.Project
   */
  public synchronized void deleteProject(Project project) {
    getProjects().removeElement(project);
    fireProjectDeleted(new ProjectDeletedEvent(this, project));

    return;
  }

  /**
   * Method to support listener events.
   */
  protected void fireProjectAdded(ProjectAddedEvent e) {
    if (aProjectChangedListener == null) {
      return;
    };

    int currentSize = aProjectChangedListener.size();
    ProjectChangedListener tempListener = null;

    for (int index = 0; index < currentSize; index++){
      tempListener = (ProjectChangedListener)aProjectChangedListener.elementAt(index);

      if (tempListener != null) {
        tempListener.projectAdded(e);
      };
    };
  }

  /**
   * Method to support listener events.
   */
  protected void fireProjectDeleted(ProjectDeletedEvent e) {
    if (aProjectChangedListener == null) {
      return;
    };

    int currentSize = aProjectChangedListener.size();
    ProjectChangedListener tempListener = null;

    for (int index = 0; index < currentSize; index++){
      tempListener = (ProjectChangedListener)aProjectChangedListener.elementAt(index);

      if (tempListener != null) {
        tempListener.projectDeleted(e);
      };
    };
  }

  /**
   * The firePropertyChange method was generated to support the propertyChange field.
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
    propertyChange.firePropertyChange(propertyName, oldValue, newValue);
  }

  /**
   * Gets the projects property (java.util.Vector) value.
   * @return The projects property value.
   * @see #setProjects
   */
  public java.util.Vector getProjects() {
    /* Returns the projects property value. */
    if (fieldProjects == null) {
      try {
        fieldProjects = new java.util.Vector();
      } catch (Throwable exception) {
        System.err.println("Exception creating projects property.");
      }
    };

    return fieldProjects;
  }

  /**
   * This method was created by a SmartGuide.
   * @return org.dbgen.Workbench
   */
  public static Workbench getTestWorkbench() {

    Table table3 = new Table();
    table3.setPackageName("org.dbgen.joblink");
    table3.setClassName("MasterBarStockDB");
    table3.setTableName("MasterBarStock");
    table3.addField(new Field(true, "BarStock", java.sql.Types.VARCHAR, 15, 0));
    table3.addField(new Field(false, "Descr", java.sql.Types.VARCHAR, 255, 0));
    table3.addField(new Field(false, "VendorNo", java.sql.Types.VARCHAR, 10, 0));
    table3.addField(new Field(false, "UOM", java.sql.Types.CHAR, 1, 0));
    table3.addField(new Field(false, "PartSize", java.sql.Types.FLOAT, 0, 0));
    table3.addField(new Field(false, "UnitPrice", java.sql.Types.FLOAT, 0, 0));
    table3.addField(new Field(false, "Markup", java.sql.Types.FLOAT, 0, 0));

    Table table4 = new Table();
    table4.setPackageName("com.twolink.joblink");
    table4.setClassName("QuoteBarStockDB");
    table4.setTableName("QuoteBarStock");
    table4.addField(new Field(true, "QuoteNo", java.sql.Types.VARCHAR, 12, 0));
    table4.addField(new Field(true, "BarStock", java.sql.Types.VARCHAR, 15, 0));
    table4.addField(new Field(false, "UOM", java.sql.Types.CHAR, 1, 0));
    table4.addField(new Field(false, "PartSize", java.sql.Types.FLOAT, 0, 0));
    table4.addField(new Field(false, "TotalPartSize", java.sql.Types.FLOAT, 0, 0));
    table4.addField(new Field(false, "UnitPrice", java.sql.Types.FLOAT, 0, 0));
    table4.addField(new Field(false, "Markup", java.sql.Types.FLOAT, 0, 0));
    table4.addField(new Field(false, "ExtendedPrice", java.sql.Types.FLOAT, 0, 0));

    Project project = new Project("Joblink");
    project.setDefaultPackageName("com.twolink.joblink");
    project.setOutputDirectory("d:\\tmp\\joblink");
    project.getTables().addElement(table3);
    project.getTables().addElement(table4);

    Workbench workbench = new Workbench();
    workbench.getProjects().addElement(project);

    return workbench;
  }

  /**
   * Remove a org.dbgen.ProjectChangedListener.
   */
  public void removeProjectChangedListener(ProjectChangedListener newListener) {
    if (aProjectChangedListener != null) {
      aProjectChangedListener.removeElement(newListener);
    };
  }

  /**
   * The removePropertyChangeListener method was generated to support the propertyChange field.
   */
  public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
    propertyChange.removePropertyChangeListener(listener);
  }

  /**
   * Sets the projects property (java.util.Vector) value.
   * @param projects The new value for the property.
   * @see #getProjects
   */
  public void setProjects(java.util.Vector projects) {
    /* Get the old property value for fire property change event. */
    java.util.Vector oldValue = fieldProjects;

    /* Set the projects property (attribute) to the new value. */
    fieldProjects = projects;

    /* Fire (signal/notify) the projects property change event. */
    firePropertyChange("projects", oldValue, projects);

    return;
  }
}
