package org.dbgen.action;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import org.dbgen.*;
import org.dbgen.view.*;
import org.dbgen.gui.*;


/**
 * This class was generated by a SmartGuide.
 *
 */
public class ImportTables extends javax.swing.AbstractAction implements WizardAction, Runnable {
  Wizard fieldWizard = null;
  ImportTableProgressFrame fieldProgressFrame = null;

  /* Transient variables used by run() */
  protected transient Object[] tableNames = null;
  protected transient MetaImporter importer = null;

  /**
   * AddProject constructor comment.
   */
  public ImportTables() {
    super("Import Tables...");
    setEnabled(false);
  }

  /**
   * This method was created by a SmartGuide.
   * @param wizard org.dbgen.gui.Wizard
   */
  public void actionPerformed(Wizard wizard) {

    WizardCard[] cards = wizard.getCards();
    ImportWizardCard2 card2 = (ImportWizardCard2) cards[1];

    importer = card2.getImporter();
    tableNames = card2.getTableList().getSelectedValues();
    int length = tableNames.length;

    ImportTableProgressFrame frame = getProgressFrame();
    frame.setup("Standing by...", 0, length);
    frame.pack();
    frame.show();

    new Thread(this).start();

    return;
  }

  /**
   * actionPerformed method comment.
   */
  public void actionPerformed(java.awt.event.ActionEvent arg1) {

    org.dbgen.Debug.println("ACTION: Import Tables");
    getWizard().showPage(0);
    getWizard().setSize(450, 350);
    getWizard().show();
  }

  /**
   * Gets the progressFrame property (org.dbgen.view.ImportTableProgressFrame) value.
   * @return The progressFrame property value.
   */
  public ImportTableProgressFrame getProgressFrame() {
    /* Returns the progressFrame property value. */
    if (fieldProgressFrame == null) {
      try {
        fieldProgressFrame = new ImportTableProgressFrame();
      } catch (Throwable exception) {
        System.err.println("Exception creating progressFrame property.");
      }
    };

    return fieldProgressFrame;
  }

  /**
   * Gets the wizard property (org.dbgen.gui.Wizard) value.
   * @return The wizard property value.
   */
  public Wizard getWizard() {
    /* Returns the wizard property value. */
    if (fieldWizard == null) {
      try {
        fieldWizard = new Wizard(DbGenPro.mainWindow, "Import Tables Wizard");
        fieldWizard.setCards(ActionHolder.importTableWizardCards);
        fieldWizard.setAction(this);
        fieldWizard.getMessage().setVisible(false);
        fieldWizard.pack();
      } catch (Throwable exception) {
        System.err.println("Exception creating wizard property.");
      }
    };

    return fieldWizard;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void run() {

    int length = tableNames.length;
    WorkbenchTreeView view = DbGenPro.mainWindow.getWorkbenchTreeView();
    Project project = view.getSelectedProject();
    ImportTableProgressFrame frame = getProgressFrame();
    frame.setTitle("Import Table Progress");

    /* Reset importer log */
    importer.clearLog();

    /* Avoid screen flickering when selecting table */
    boolean autoSelect = view.getAutoSelectTable();
    view.setAutoSelectTable(false);

    for (int i = 0; i < length; i++)
    {
      frame.update("Importing " + tableNames[i], i, false);
      Table table = importer.getTable((String) tableNames[i]);

      if (table != null)
      {
        table.setClassName((String) tableNames[i]);
        project.addTable(table);
      }
    }

    if (importer.isEmptyLog())
    {
      frame.update("All selected tables have been imported.", length, true);
    }
    else
    {
      frame.update("There were some errors.", length, true);
      org.dbgen.view.Util.showErrorBuffer(frame, importer.getLog(), "Import Errors");

      //		System.out.println("IMPORT ERRORS: ");
      //		System.out.println(importer.getLog());
    }

    /* Restore auto select property */
    view.setAutoSelectTable(autoSelect);

    return;
  }
}
