package org.dbgen.gui;

/**
 * This interface is implemented by all "screens" (wizard cards) inside
 * a Wizard dialog.
 *
 */
public interface WizardCard {


  /**
   * This method is called after the wizard card has been shown inside the wizard.
   * @param wizard org.dbgen.gui.Wizard
   */
  public void cardShown(Wizard wizard);

  /**
   * Test if the Finish button can be enabled.
   * @return True if the Finish button should be enabled.
   */
  public boolean enableFinishButton();

  /**
   * Test if the Next button can be enabled.
   * @return True if the Next button should be enabled.
   */
  public boolean enableNextButton();

  /**
   * Get the wizard card name (used in the CardLayout)
   * @return The wizard card name.
   */
  public String getCardName();

  /**
   * This method is called when the Next button is pressed and is used
   * to test if it is ok to proceed to the next card.
   * @return True if it is ok to proceed to the next card.
   */
  public boolean proceedNext();
}
