package org.dbgen.support;

import java.util.*;

/**
 * Data is a common interface that must be implemented by all table
 * object classes generated by DbGen.  It provides the foundation
 * of constructing dynamic SQL statements using data fields of the
 * table object.
 */
public interface Data {
  /**
   * Get the comma-delimited list for a SQL INSERT statement.
   * @return The comma-delimited list for a SQL INSERT statement.
   */
  public String getInsertValues();

  /**
   * Get the SQL condition string for a SQL SELECT/UPDATE statement.
   * @return The SQL condition string for a SQL SELECT/UPDATE statement.
   */
  public String getKeyConditions();

  /**
   * This method was created in VisualAge.
   * @param dbData org.dbgen.support.Data
   */
  public String getKeyConditions( Data masterTableClass );

  /**
   * Get the table name for this Data object.
   * @return The table name for this Data object.
   */
  public String getTableName();

  /**
   * Get the comma-delimited string for a SQL UPDATE statement.
   * @return The comma-delimited string for a SQL UPDATE statement.
   */
  public String getUpdateValues();

  /**
   * Make a new Data object based on the next row from a ResultSet.
   * @return The Data object created.
   * @param rs The ResultSet to retrieve data.
   * @exception java.sql.SQLException When a SQL Exception occurred.
   */
  public org.dbgen.support.Data makeObject(java.sql.ResultSet rs) throws java.sql.SQLException;
}
