package org.dbgen.support;

/**
 * General string parsing routines.
 *
 */
public class Parsing {
  /**
   * Convert a string to Double.
   * @param s java.lang.String
   */
  public static double parseDouble(String s) {
    double f = 0.0;

    try {
      f = Double.valueOf(s).doubleValue();
    } catch (NumberFormatException e) {
      e.printStackTrace();
    }

    return f;
  }

  /**
   * Convert a string to Float.
   * @return float
   * @param s java.lang.String
   */
  public static float parseFloat(String s) {
    float f = (float) 0.0;

    try {
      f = Float.valueOf(s).floatValue();
    } catch (NumberFormatException e) {
      e.printStackTrace();
    }

    return f;
  }
}
