package org.dbgen.view;

import java.io.*;
import java.util.*;
import javax.swing.*;

public class DefaultComboBoxModel extends AbstractListModel implements ComboBoxModel, Serializable {
  Vector objects = new Vector();
  Object selectedObject;

  public DefaultComboBoxModel() {
  }

  public DefaultComboBoxModel(final Object items[]) {
    int i,c;

    for ( i=0,c=items.length;i<c;i++ )
      objects.addElement(items[i]);
  }

  public DefaultComboBoxModel(Vector v) {
    int i,c;

    for ( i=0,c=v.size();i<c;i++ )
      objects.addElement(v.elementAt(i));
  }

  void addObject(Object anObject) {
    objects.addElement(anObject);
    fireIntervalAdded(this,objects.size()-1, objects.size()-1);
  }

  public Object getElementAt(int index) {
    if ( index >= 0 && index < objects.size() )
      return objects.elementAt(index);
    else
      return null;
  }

  public int getIndexOf(Object anObject) {
    return objects.indexOf(anObject);
  }

  public Object getSelectedItem() {
    return selectedObject;
  }

  public int getSize() {
    return objects.size();
  }

  void insertObjectAt(Object anObject,int index) {
    objects.insertElementAt(anObject,index);
    fireIntervalAdded(this, index, index);
  }

  void removeAllObjects() {
    int firstIndex = 0;
    int lastIndex = objects.size()-1;
    objects.removeAllElements();
    fireIntervalRemoved(this, firstIndex, lastIndex);
  }

  void removeObject(Object anObject) {
    int index = objects.indexOf(anObject);

    if ( index != -1 ) {
      removeObjectAt(index);
    }
  }

  void removeObjectAt(int index) {
    objects.removeElementAt(index);
    fireIntervalRemoved(this, index, index);
  }

  /**
   * This method was created in VisualAge.
   * @param objs java.util.Vector
   */
  public void setObjects( Vector objs) {
    objects = objs;

    try {
      if ( objs == null )
        removeAllObjects();
      else
        fireIntervalAdded(this,0, objects.size()-1);
    } catch ( Exception ex ) {
    }
  }

  public void setSelectedItem(Object anObject) {
    selectedObject = anObject;
    fireContentsChanged(this, -1, -1);
  }
}
