package org.dbgen.view;

import java.awt.*;
import java.beans.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.table.*;
import org.dbgen.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class TableView extends javax.swing.JPanel
  implements TextFieldListener, ActionListener, ListSelectionListener {

  javax.swing.JTabbedPane fieldTab = null;
  javax.swing.JPanel fieldGeneralPanel = null;
  javax.swing.JPanel fieldFieldsPanel = null;
  javax.swing.JPanel fieldRelationsPanel = null;
  org.dbgen.view.TextField fieldTableNameField = null;
  org.dbgen.view.TextField fieldClassNameField = null;
  org.dbgen.view.TextField fieldPackageNameField = null;
  protected final static int TABLE_NAME_FIELD = 1;
  protected final static int CLASS_NAME_FIELD = 2;
  protected final static int PACKAGE_NAME_FIELD = 3;
  protected final static int OUTPUT_DIRECTORY_FIELD = 4;
  Table fieldTable = null;
  JTable fieldFieldsTable = null;
  JButton addButton = null;
  JButton deleteButton = null;
  JButton addButton2 = null;
  JButton deleteButton2 = null;
  JButton helpButton = null;
  TableCellEditor typeCellEditor = new DefaultCellEditor(Util.createFieldTypesComboBox());

  private JTable fieldRelationsTable = null;
  private DefaultComboBoxModel fieldMasterKeyComboBoxModel = null;
  private DefaultComboBoxModel fieldForeignTableComboBoxModel = null;
  private DefaultComboBoxModel fieldForeignKeyComboBoxModel = null;
  private JComboBox fieldCmbMasterKey = null;
  private JComboBox fieldCmbForeignTable = null;
  private JComboBox fieldCmbForeignKey = null;
  private DefaultCellEditor fieldCedMasterKey = null;
  private DefaultCellEditor fieldCedForeignTable = null;
  private DefaultCellEditor fieldCedForeignKey = null;

  private TableSorter relationTableSorter = null;

  static final int COLUMN_MASTER_KEY = 0;
  static final int COLUMN_FOREIGN_TABLE = 1;
  static final int COLUMN_FOREIGN_KEY = 2;

  class RelationCellEditor extends DefaultCellEditor {
    public RelationCellEditor(JComboBox x) {
      super(x);
    }
  }

  /**
   * TableView constructor comment.
   */
  public TableView() {
    super();
    initialize();
  }

  /**
   * This method was created by a SmartGuide.
   * @param event ActionEvent
   */
  public void actionPerformed(ActionEvent event) {

    JButton source = (JButton) event.getSource();
    int row;

    if (source == addButton)
    {
      int currSize = getTable().getFields().size();
      getTable().addDefaultField();
      row = currSize;
      getFieldsTable().setRowSelectionInterval(row, row);
    }
    else if (source == deleteButton)
    {
      row = getFieldsTable().getSelectedRow();
      getTable().deleteField(getTable().getField(row));

      /* select last item if the last field was deleted */
      if (row == getTable().getFields().size())
        row--;
      getFieldsTable().setRowSelectionInterval(row, row);
    }
    else if (source == addButton2)
    {
      int currSize = getTable().getRelations().size();
      getTable().addDefaultRelation();
      row = currSize;
      getRelationsTable().setRowSelectionInterval(row, row);

      getRelationsTable().getColumnModel().getColumn(COLUMN_MASTER_KEY).setCellEditor(
        fieldCedMasterKey);
      getRelationsTable().getColumnModel().getColumn(COLUMN_FOREIGN_TABLE).setCellEditor(
        fieldCedForeignTable);
      getRelationsTable().getColumnModel().getColumn(COLUMN_FOREIGN_KEY).setCellEditor(
        fieldCedForeignKey);

      getRelationsTable().getTableHeader().resizeAndRepaint();

      new TableHeaderRenderer(
        getRelationsTable().getModel(),
        getRelationsTable().getTableHeader()
        );

      getRelationsTable().editCellAt(
        getRelationsTable().getSelectedRow(),
        COLUMN_MASTER_KEY
        );

      getCmbMasterKey().setSize(
        new Dimension(
          getRelationsTable().getWidth()/3,
          18
          )
        );
      getCmbMasterKey().showPopup();
    }
    else if (source == deleteButton2)
    {
      getRelationsTable().editingStopped( new javax.swing.event.ChangeEvent(this));

      row = getRelationsTable().getEditingRow();

      if ( row < 0 ) {
        row = getRelationsTable().getSelectedRow();

        if ( row < 0 )
          return;
      }

      row = relationTableSorter.getMappedIndex(row);

      getTable().deleteRelation(getTable().getRelation(row));

      /* select last item if the last field was deleted */
      if (row == getTable().getRelations().size())
        row--;
      getRelationsTable().setRowSelectionInterval(row, row);

      new TableHeaderRenderer(
        getRelationsTable().getModel(),
        getRelationsTable().getTableHeader()
        );

      //		if ( getRelationsTable().isEditing() )

      //		refreshComboBox();
    }
    else if (source == helpButton)
    {
      String msg = "Instruction:\n";
      msg = msg + "To add a relation, click on 'Add Relation' button then double click on the cell to start editing.\n";
      msg = msg + "To delete a relation, select the relation row then click on the 'Delete Relation' button.\n";

      msg = msg + "\nDescription:\n";
      msg = msg + "Master Key - The key of this table mapping to the foreign key.\n";
      msg = msg + "Foreign Table - Table which contains the foreign key to be mapped.\n";
      msg = msg + "Foreign Key - Foreign key to be mapped.\n";

      msg = msg + "\nTips:\n";
      msg = msg + "Click on the table header to sort the column.\n";
      msg = msg + "You can define more than one foreign key from the same foreign table.\n\n";

      org.dbgen.gui.CommonDialog.showInformation(this, "Help on Relation Settings", msg);
    }
    else
    {
      throw new RuntimeException("BUG: Cannot find action button " + event);
    }

    //	org.dbgen.Debug.println("Selecting row " + row);

    return;
  }

  /**
   * Gets the classNameField property (org.dbgen.view.TextField) value.
   * @return The classNameField property value.
   */
  public org.dbgen.view.TextField getClassNameField() {
    /* Returns the classNameField property value. */
    if (fieldClassNameField == null) {
      try {
        fieldClassNameField = new org.dbgen.view.TextField();
        fieldClassNameField.addSetFieldListener(this, CLASS_NAME_FIELD);
      } catch (Throwable exception) {
        System.err.println("Exception creating classNameField property.");
      }
    };

    return fieldClassNameField;
  }

  /**
   * Gets the cmbForeignKey property (javax.swing.JComboBox) value.
   * @return The cmbForeignKey property value.
   */
  public JComboBox getCmbForeignKey() {
    if ( fieldCmbForeignKey == null )
      fieldCmbForeignKey = new JComboBox( getForeignKeyComboBoxModel() );

    return fieldCmbForeignKey;
  }

  /**
   * Gets the cmbForeignTable property (javax.swing.JComboBox) value.
   * @return The cmbForeignTable property value.
   */
  public JComboBox getCmbForeignTable() {
    if ( fieldCmbForeignTable == null )
      fieldCmbForeignTable = new JComboBox( getForeignTableComboBoxModel() );

    return fieldCmbForeignTable;
  }

  /**
   * Gets the cmbMasterKey property (javax.swing.JComboBox) value.
   * @return The cmbMasterKey property value.
   * @see #setCmbMasterKey
   */
  public JComboBox getCmbMasterKey() {
    if ( fieldCmbMasterKey == null )
      fieldCmbMasterKey = new JComboBox( getMasterKeyComboBoxModel() );

    return fieldCmbMasterKey;
  }

  /**
   * Gets the fieldsPanel property (javax.swing.JPanel) value.
   * @return The fieldsPanel property value.
   */
  public javax.swing.JPanel getFieldsPanel() {
    /* Returns the fieldsPanel property value. */
    if (fieldFieldsPanel == null) {
      try {
        fieldFieldsPanel = new javax.swing.JPanel();
      } catch (Throwable exception) {
        System.err.println("Exception creating fieldsPanel property.");
      }
    };

    return fieldFieldsPanel;
  }

  /**
   * Gets the fieldsTable property (javax.swing.JTable) value.
   * @return The fieldsTable property value.
   */
  public JTable getFieldsTable() {
    /* Returns the fieldsTable property value. */
    if (fieldFieldsTable == null) {
      try {
        fieldFieldsTable = new JTable();
      } catch (Throwable exception) {
        System.err.println("Exception creating fieldsTable property.");
      }
    };

    return fieldFieldsTable;
  }

  /**
   * Gets the foreignKeyComboBoxModel property (org.dbgen.view.DefaultComboBoxModel) value.
   * @return The foreignKeyComboBoxModel property value.
   */
  public DefaultComboBoxModel getForeignKeyComboBoxModel() {
    if ( fieldForeignKeyComboBoxModel == null )
      fieldForeignKeyComboBoxModel = new DefaultComboBoxModel();

    return fieldForeignKeyComboBoxModel;
  }

  /**
   * Gets the foreignTableComboBoxModel property (org.dbgen.view.DefaultComboBoxModel) value.
   * @return The foreignTableComboBoxModel property value.
   */
  public DefaultComboBoxModel getForeignTableComboBoxModel() {
    if ( fieldForeignTableComboBoxModel == null )
      fieldForeignTableComboBoxModel = new DefaultComboBoxModel();

    return fieldForeignTableComboBoxModel;
  }

  /**
   * Gets the generalPanel property (javax.swing.JPanel) value.
   * @return The generalPanel property value.
   */
  public javax.swing.JPanel getGeneralPanel() {
    /* Returns the generalPanel property value. */
    if (fieldGeneralPanel == null) {
      try {
        fieldGeneralPanel = new javax.swing.JPanel();
      } catch (Throwable exception) {
        System.err.println("Exception creating generalPanel property.");
      }
    };

    return fieldGeneralPanel;
  }

  /**
   * Gets the masterKeyComboBoxModel property (org.dbgen.view.DefaultComboBoxModel) value.
   * @return The masterKeyComboBoxModel property value.
   */
  public DefaultComboBoxModel getMasterKeyComboBoxModel() {
    if ( fieldMasterKeyComboBoxModel == null )
      fieldMasterKeyComboBoxModel = new DefaultComboBoxModel();

    return fieldMasterKeyComboBoxModel;
  }

  /**
   * Gets the packageNameField property (org.dbgen.view.TextField) value.
   * @return The packageNameField property value.
   */
  public org.dbgen.view.TextField getPackageNameField() {
    /* Returns the packageNameField property value. */
    if (fieldPackageNameField == null) {
      try {
        fieldPackageNameField = new org.dbgen.view.TextField();
        fieldPackageNameField.addSetFieldListener(this, PACKAGE_NAME_FIELD);
      } catch (Throwable exception) {
        System.err.println("Exception creating packageNameField property.");
      }
    };

    return fieldPackageNameField;
  }

  /**
   * Gets the relationsPanel property (javax.swing.JPanel) value.
   * @return The relationsPanel property value.
   */
  public javax.swing.JPanel getRelationsPanel() {
    /* Returns the relationsPanel property value. */
    if (fieldRelationsPanel == null) {
      try {
        fieldRelationsPanel = new javax.swing.JPanel();
      } catch (Throwable exception) {
        System.err.println("Exception creating relationsPanel property.");
      }
    };

    return fieldRelationsPanel;
  }

  /**
   * Gets the relationsTable property (javax.swing.JTable) value.
   * @return The relationsTable property value.
   */
  public JTable getRelationsTable() {
    /* Returns the fieldRelationsTable property value. */
    if (fieldRelationsTable == null) {
      try {
        fieldRelationsTable = new JTable() {
          public boolean editCellAt(int row, int column, EventObject e) {
            //System.out.println( row +" " + column );
            try {

              if ( column == COLUMN_FOREIGN_KEY ) {
                Object t = getRelationsTable().getValueAt(row, COLUMN_FOREIGN_TABLE);
                Object f = getRelationsTable().getValueAt(row, COLUMN_MASTER_KEY);

                if ( t instanceof Table && f instanceof Field) {
                  loadCmbForeignKey((Table) t, (Field) f);
                }
              }
            } catch ( Exception ex ) {
              ex.printStackTrace();
            }

            return super.editCellAt(row, column, e);
          }
        };
      } catch (Throwable exception) {
        System.err.println("Exception creating fieldRelationsTable property.");
      }
    };

    return fieldRelationsTable;
  }

  /**
   * Gets the tab property (javax.swing.JTabbedPane) value.
   * @return The tab property value.
   */
  public javax.swing.JTabbedPane getTab() {
    /* Returns the tab property value. */
    if (fieldTab == null) {
      try {
        fieldTab = new javax.swing.JTabbedPane();
      } catch (Throwable exception) {
        System.err.println("Exception creating tab property.");
      }
    };

    return fieldTab;
  }

  /**
   * Gets the table property (org.dbgen.Table) value.
   * @return The table property value.
   * @see #setTable
   */
  public Table getTable() {
    /* Returns the table property value. */
    if (fieldTable == null) {
      try {
        fieldTable = new Table();
      } catch (Throwable exception) {
        System.err.println("Exception creating table property.");
      }
    };

    return fieldTable;
  }

  /**
   * Gets the tableNameField property (org.dbgen.view.TextField) value.
   * @return The tableNameField property value.
   */
  public org.dbgen.view.TextField getTableNameField() {
    /* Returns the tableNameField property value. */
    if (fieldTableNameField == null) {
      try {
        fieldTableNameField = new org.dbgen.view.TextField();
        fieldTableNameField.addSetFieldListener(this, TABLE_NAME_FIELD);
      } catch (Throwable exception) {
        System.err.println("Exception creating tableNameField property.");
      }
    };

    return fieldTableNameField;
  }

  /**
   * This method was created in VisualAge.
   */
  public void initConnections() {
    /*
     getCmbMasterKey().addActionListener(
     new ActionListener() {
     public void actionPerformed( ActionEvent ev )
     {
     
     JTable tbl = getRelationsTable();
     tbl.revalidate();
     tbl.repaint();
     }
     }
     );
     */
    //	getCmbMasterKey().addItemListener(this);
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void initialize() {

    GridBagConstraints c = new GridBagConstraints();
    int i = 0;

    JPanel generalPanel = getGeneralPanel();
    generalPanel.setLayout(new GridBagLayout());

    //generalPanel.setBorder(new BevelBorder(BevelBorder.RAISED));
    Util.addGridBagComponent(generalPanel, c, ++i, new JLabel("Table Name"));
    Util.addGridBagComponent(generalPanel, c, ++i, getTableNameField());
    Util.addGridBagComponent(generalPanel, c, ++i, new JLabel("Class Name"));
    Util.addGridBagComponent(generalPanel, c, ++i, getClassNameField());
    Util.addGridBagComponent(generalPanel, c, ++i, new JLabel("Package Name (overrides project setting)"));
    Util.addGridBagComponent(generalPanel, c, ++i, getPackageNameField());

    // Table Fields
    JPanel fieldsPanel = getFieldsPanel();
    fieldsPanel.setLayout(new BorderLayout());

    //JScrollPane scrollPane = JTable.createScrollPaneForTable(getFieldsTable());
    //scrollPane.setPreferredSize(new Dimension(400, 300));
    JScrollPane scrollPane = new JScrollPane(getFieldsTable());

    JPanel buttonsPanel = new JPanel(new GridLayout(1, 2));
    buttonsPanel.add(addButton = new JButton("Add Data Field"));
    buttonsPanel.add(deleteButton = new JButton("Delete Data Field"));
    addButton.addActionListener(this);
    deleteButton.addActionListener(this);

    fieldsPanel.add(BorderLayout.CENTER, scrollPane);
    fieldsPanel.add(BorderLayout.SOUTH, buttonsPanel);


    // Relation Fields
    JPanel relationsPanel = getRelationsPanel();
    relationsPanel.setLayout(new BorderLayout());

    JScrollPane scrollPane2 = new JScrollPane(getRelationsTable());

    JPanel buttonsPanel2 = new JPanel(new GridLayout(1, 3));
    buttonsPanel2.add(addButton2 = new JButton("Add Relation"));
    buttonsPanel2.add(deleteButton2 = new JButton("Delete Relation"));
    buttonsPanel2.add(helpButton = new JButton("Help"));
    addButton2.addActionListener(this);
    deleteButton2.addActionListener(this);
    helpButton.addActionListener(this);

    relationsPanel.add(BorderLayout.CENTER, scrollPane2);
    relationsPanel.add(BorderLayout.SOUTH, buttonsPanel2);

    fieldCedMasterKey = new DefaultCellEditor( getCmbMasterKey());
    fieldCedForeignTable = new DefaultCellEditor( getCmbForeignTable());
    fieldCedForeignKey = new DefaultCellEditor( getCmbForeignKey());
    fieldCedMasterKey.setClickCountToStart(2);
    fieldCedForeignTable.setClickCountToStart(2);
    fieldCedForeignKey.setClickCountToStart(2);

    /*
     relationsPanel = getRelationsPanel();
     relationsPanel.setLayout(new BorderLayout());
     relationsPanel.add(BorderLayout.CENTER, new JLabel("Not available yet.", SwingConstants.CENTER));
     */
    JTabbedPane tab = getTab();
    tab.addTab("General", null, generalPanel);
    tab.addTab("Fields", null, fieldsPanel);
    tab.addTab("Relations", null, relationsPanel);

    setLayout(new BorderLayout());
    add(BorderLayout.CENTER, tab);

    initConnections();

    return;
  }

  /**
   * This method was created in VisualAge.
   */
  public void loadCmbForeignKey( Table foreignTable, Field masterKey) {

    try {

      if ( foreignTable == null || masterKey == null ) {
        getForeignKeyComboBoxModel().setObjects(null);

        return;
      }

      Vector fields = new Vector();
      Vector foreignKeys = foreignTable.getFields();

      for ( int i=0; i<foreignKeys.size(); i++ ) {
        Field f = (Field) foreignKeys.elementAt(i);

        if ( f.getType() == masterKey.getType() &&
          f.getLength() == masterKey.getLength() &&
          f.getScale() == masterKey.getScale() )
          fields.addElement(f);
      }

      getForeignKeyComboBoxModel().setObjects(fields);
    } catch ( Exception ex ) {
      ex.printStackTrace();
    }
  }

  /**
   * This method was created in VisualAge.
   */
  public void loadCmbForeignTable() {
    try {

      getForeignTableComboBoxModel().setObjects( getTable().getForeignTables());
    } catch ( Exception ex ) {
      ex.printStackTrace();
    }
  }

  /**
   * This method was created in VisualAge.
   */
  public void loadCmbMasterKey() {
    try {

      getMasterKeyComboBoxModel().setObjects( getTable().getFields());
    } catch ( Exception ex ) {
      ex.printStackTrace();
    }
  }

  /**
   * This method was created by a SmartGuide.
   * @param id int
   * @param value java.lang.String
   */
  public void setField(int id, String value) {

    switch (id)
    {
    case TABLE_NAME_FIELD:
      getTable().setTableName(value);
    break;

    case CLASS_NAME_FIELD:
      getTable().setClassName(value);
    break;

    case PACKAGE_NAME_FIELD:
      getTable().setPackageName(value);
    break;
    default:
      throw new RuntimeException("BUG: Cannot set table field id=" + id + " value=" + value);
    }

    // XXX - DEBUG
    //getTable().dump();

    return;
  }

  /**
   * Sets the table property (org.dbgen.Table) value.
   * @param table The new value for the property.
   * @see #getTable
   */
  public void setTable(Table table) {
    /* Get the old property value for fire property change event. */
    Table oldValue = fieldTable;

    /* Set the table property (attribute) to the new value. */
    fieldTable = table;

    /* Fire (signal/notify) the table property change event. */
    firePropertyChange("table", oldValue, table);


    //	getRelationsTable().editingStopped( new javax.swing.event.ChangeEvent(this));

    /* Update General Information */
    getTableNameField().setText(table.getTableName());
    getClassNameField().setText(table.getClassName());
    getPackageNameField().setText(table.getPackageName());

    /* Update Fields Information */
    getFieldsTable().setModel(new TableFieldsModel(table));
    getFieldsTable().setDefaultEditor(FieldType.class, typeCellEditor);
    getFieldsTable().getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    /* Update Fields Information */
    TableRelationsModel relationModel = new TableRelationsModel(table);

    //	relationModel.setJTable(getRelationsTable());

    relationTableSorter = new TableSorter(relationModel);
    getRelationsTable().setModel(relationTableSorter);

    relationTableSorter.addMouseListenerToHeaderInTable(getRelationsTable());
    new TableHeaderRenderer( relationTableSorter, getRelationsTable().getTableHeader());


    getRelationsTable().getColumnModel().getColumn(COLUMN_MASTER_KEY).setCellEditor(
      fieldCedMasterKey);
    getRelationsTable().getColumnModel().getColumn(COLUMN_FOREIGN_TABLE).setCellEditor(
      fieldCedForeignTable);
    getRelationsTable().getColumnModel().getColumn(COLUMN_FOREIGN_KEY).setCellEditor(
      fieldCedForeignKey);


    //	getMasterKeyComboBoxModel().setObjects( getTable().getFields());
    loadCmbMasterKey();
    loadCmbForeignTable();

    //	fieldCedMasterKey.addCellEditorListener(this);
    //	fieldCedForeignTable.addCellEditorListener(this);
    //	fieldCedForeignKey.addCellEditorListener(this);

    getRelationsTable().getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);


    /* Update Relations Information */
    // XXX - need implementation

    return;
  }

  /**
   * TESTING
   * @param args java.lang.String[]
   */
  public static void test(java.lang.String[] args) {

    Table table = new Table();
    table.setPackageName("org.dbgen.test");
    table.setClassName("Zip");
    table.setTableName("zip");
    table.addField(new Field(true, "zip_code", java.sql.Types.VARCHAR, 10, 0));
    table.addField(new Field(false, "state_code", java.sql.Types.CHAR, 2, 0));
    table.addField(new Field(false, "city_name", java.sql.Types.VARCHAR, 30, 0));
    table.addField(new Field(false, "county_name", java.sql.Types.VARCHAR, 30, 0));
    table.addField(new Field(false, "county_code", java.sql.Types.VARCHAR, 4, 0));

    JFrame frame = new JFrame("TableView Test");
    TableView view = new TableView();
    view.setTable(table);
    frame.getContentPane().add(view);
    frame.pack();
    frame.show();
  }

  /**
   * This method was created in VisualAge.
   * @param ev javax.swing.event.ListSelectionEvent
   */
  public void valueChanged( ListSelectionEvent ev ) {
    if ( ev.getValueIsAdjusting() ||
      getRelationsTable().getSelectedRowCount() <= 0)
      return;

    //System.out.println(getRelationsTable().getSelectedRowCount());
    //System.out.println(getRelationsTable().getSelectedColumn());

    // reload the foreign key column
    Object t = getRelationsTable().getValueAt(
      getRelationsTable().getSelectedRow(), COLUMN_FOREIGN_TABLE);

    if ( !(t instanceof Table))
      return;

    Object f = getRelationsTable().getValueAt(
      getRelationsTable().getSelectedRow(), COLUMN_MASTER_KEY);

    if ( !(f instanceof Field))
      return;

    loadCmbForeignKey((Table) t, (Field) f);
  }
}
