package org.dbgen.view;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;
import java.beans.*;
import org.dbgen.*;
import org.dbgen.event.*;

/**
 * This class was generated by a SmartGuide.
 *
 */
public class WorkbenchTreeView extends JTree implements java.beans.PropertyChangeListener, ProjectChangedListener, TableChangedListener, TreeSelectionListener, Scrollable {
  Workbench fieldWorkbench = null;
  public DefaultMutableTreeNode root;
  ProjectSelectionModel fieldProjectSelectionModel = null;
  protected transient Vector aProjectSelectionListener = null;
  Table fieldSelectedTable = null;
  Project fieldSelectedProject = null;

  // selection levels
  public final static int NOTHING_SELECTED = 0;
  public final static int ROOT_SELECTED = 1;
  public final static int PROJECT_SELECTED = 2;
  public final static int TABLE_SELECTED = 3;
  boolean fieldAutoSelectTable = false;

  String fieldMessage = "";

  /**
   * WorkbenchTreeView constructor comment.
   */
  public WorkbenchTreeView() {
    super();
    initialize();
  }

  /**
   * WorkbenchTreeView constructor comment.
   * @param arg1 java.lang.Object[]
   */
  public WorkbenchTreeView(java.lang.Object[] arg1) {
    super(arg1);
    initialize();
  }

  /**
   * This method was created by a SmartGuide.
   */
  protected void createTree() {

    root = new DefaultMutableTreeNode(getWorkbench());

    Vector projects = getWorkbench().getProjects();
    Project project;
    Table table;

    for (int i = 0; i < projects.size(); i++)
    {
      project = (Project) projects.elementAt(i);
      ProjectTreeNode projectNode = new ProjectTreeNode(project);
      root.add(projectNode);

      /* listen to table add/delete event and project property changes. */
      project.addTableChangedListener(this);
      project.addPropertyChangeListener(this);

      Vector tables = project.getTables();

      for (int j = 0; j < tables.size(); j++)
      {
        table = (Table) tables.elementAt(j);
        TableTreeNode tableNode = new TableTreeNode(table);
        projectNode.add(tableNode);
        table.addPropertyChangeListener(this);
      }
    }

    setRootVisible(false);
    setModel(new DefaultTreeModel(root));

    setSelectionInterval(0, 0);

    if (projects.size() == 1)
    {
      expandRow(0);
    }

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @return org.dbgen.ProjectTreeNode
   */
  public ProjectTreeNode findSelectedProjectNode() {

    TreePath path = getSelectionPath();

    if (path != null)
    {
      ProjectTreeNode node = (ProjectTreeNode) path.getPathComponent(1);

      return node;
    }

    return null;
  }

  /**
   * This method was created by a SmartGuide.
   * @return org.dbgen.TableTreeNode
   */
  protected TableTreeNode findSelectedTableNode() {

    TreePath path = getSelectionPath();

    if (path != null)
    {
      TableTreeNode node = (TableTreeNode) path.getPathComponent(2);

      return node;
    }

    return null;
  }

  /**
   * Gets the autoSelectTable property (boolean) value.
   * @return The autoSelectTable property value.
   * @see #setAutoSelectTable
   */
  public boolean getAutoSelectTable() {
    /* Returns the autoSelectTable property value. */
    return fieldAutoSelectTable;
  }

  /**
   * Gets the message property (java.lang.String) value.
   * @return The message property value.
   * @see #setMessage
   */
  public String getMessage() {
    /* Returns the message property value. */
    if (fieldMessage == null) {
      try {
        fieldMessage = new String();
      } catch (Throwable exception) {
        System.err.println("Exception creating message property.");
      }
    };

    return fieldMessage;
  }

  /**
   * This method was created by a SmartGuide.
   * @return java.awt.Dimension
   */
  public java.awt.Dimension getMinimumSize() {
    return new java.awt.Dimension(150, 200);
  }

  /**
   * Gets the selectedProject property (org.dbgen.Project) value.
   * @return The selectedProject property value.
   * @see #setSelectedProject
   */
  public Project getSelectedProject() {
    /* Returns the selectedProject property value. */
    if (fieldSelectedProject == null) {
      try {
        fieldSelectedProject = new Project();
      } catch (Throwable exception) {
        System.err.println("Exception creating selectedProject property.");
      }
    };

    return fieldSelectedProject;
  }

  /**
   * Gets the selectedTable property (org.dbgen.Table) value.
   * @return The selectedTable property value.
   * @see #setSelectedTable
   */
  public Table getSelectedTable() {
    /* Returns the selectedTable property value. */
    if (fieldSelectedTable == null) {
      try {
        fieldSelectedTable = new Table();
      } catch (Throwable exception) {
        System.err.println("Exception creating selectedTable property.");
      }
    };

    return fieldSelectedTable;
  }

  /**
   * This method was created by a SmartGuide.
   * @return int
   */
  public int getSelectionLevel() {

    TreePath path = getSelectionPath();

    if (path == null)
    {
      return -1;
    }
    else
    {
      return path.getPathCount();
    }
  }

  /**
   * Gets the workbench property (org.dbgen.Workbench) value.
   * @return The workbench property value.
   * @see #setWorkbench
   */
  public Workbench getWorkbench() {
    /* Returns the workbench property value. */
    if (fieldWorkbench == null) {
      try {
        fieldWorkbench = new Workbench();
      } catch (Throwable exception) {
        System.err.println("Exception creating workbench property.");
      }
    };

    return fieldWorkbench;
  }

  /**
   * This method was created by a SmartGuide.
   */
  public void initialize() {
    setAutoSelectTable(true);
    addTreeSelectionListener(this);
    setCellRenderer( new TreeViewRenderer() );

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event org.dbgen.ProjectAddedEvent
   */
  public void projectAdded(ProjectAddedEvent event) {

    org.dbgen.Debug.println("WorkbenchTreeView.projectAdded() - " + event.getProject());

    Project project = event.getProject();
    ProjectTreeNode newNode = new ProjectTreeNode(project);

    int index = Util.findObjectFromVector(project, getWorkbench().getProjects());
    root.insert(newNode, index);

    /* Add table change listener */
    project.addTableChangedListener(this);
    project.addPropertyChangeListener(this);

    /* Refresh the tree */
    DefaultTreeModel tm = (DefaultTreeModel) getModel();
    tm.nodesWereInserted(root, new int[] { index });

    //reload(root);

    /* Set selected project to this new one */
    //getProjectSelectionModel().setSelectedProject(event.getProject());
    selectProject(newNode);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event org.dbgen.ProjectDeletedEvent
   */
  public void projectDeleted(ProjectDeletedEvent event) {

    org.dbgen.Debug.println("WorkbenchTreeView.projectDeleted() - " + event.getProject());

    ProjectTreeNode projectNode = findSelectedProjectNode();
    ProjectTreeNode nextNode = (ProjectTreeNode) projectNode.getNextSibling();
    int index = root.getIndex(projectNode);
    int count = root.getChildCount();
    int newIndex = (index == count-1) ? index-1 : index;

    /* Remove the project node */
    root.remove(projectNode);

    /* Notify Jtree about the removal */
    DefaultTreeModel tm = (DefaultTreeModel) getModel();
    tm.nodesWereRemoved(root, new int[] { index }, new Object[] { event.getProject() });

    //reload(parent);

    /* Select next project node */
    if (newIndex >= 0)
      selectProject((ProjectTreeNode) root.getChildAt(newIndex));
    else
      setMessage("emptyWorkbench");

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event PropertyChangeEvent
   */
  public void propertyChange(PropertyChangeEvent event) {

    Object source = event.getSource();
    String propertyName = event.getPropertyName();

    if ("projectName".equals(propertyName))
    {
      reload(findSelectedProjectNode());    // since it must be the selected one
    }
    else if ("tableName".equals(propertyName) || "className".equals(propertyName))
    {
      reload(findSelectedTableNode());    // since it must be the selected one
    }
    else if ("selectedProject".equals(propertyName))
    {
      Project project = (Project) event.getNewValue();
      selectProject(project);
    }

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param node javax.swing.tree.DefaultMutableTreeNode
   */
  public void reload(DefaultMutableTreeNode node) {
    ((DefaultTreeModel) getModel()).reload(node);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param project org.dbgen.Project
   */
  public void selectProject(Project project) {

    for (int i = 0; i < root.getChildCount(); i++)
    {
      ProjectTreeNode curr = (ProjectTreeNode) root.getChildAt(i);
      org.dbgen.Debug.println("TEST " + curr + " -> " + curr.getProject());

      if (curr.getProject() == project)
      {
        setSelectionPath(new TreePath(new Object[] { root, curr }));
      }
    }

    throw new RuntimeException("WorkbenchTreeView.selectProject() - Cannot find project " + project);
  }

  /**
   * This method was created by a SmartGuide.
   * @param index int
   */
  public void selectProject(ProjectTreeNode projectNode) {
    setSelectionPath(new TreePath(new Object[] { root, projectNode }));

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param projectNode org.dbgen.view.ProjectTreeNode
   * @param tableNode org.dbgen.view.TableTreeNode
   */
  public void selectTable(ProjectTreeNode projectNode, TableTreeNode tableNode) {
    setSelectionPath(new TreePath(new Object[] { root, projectNode, tableNode }));

    return;
  }

  /**
   * Sets the autoSelectTable property (boolean) value.
   * @param autoSelectTable The new value for the property.
   * @see #getAutoSelectTable
   */
  public void setAutoSelectTable(boolean autoSelectTable) {
    /* Get the old property value for fire property change event. */
    boolean oldValue = fieldAutoSelectTable;

    /* Set the autoSelectTable property (attribute) to the new value. */
    fieldAutoSelectTable = autoSelectTable;

    /* Fire (signal/notify) the autoSelectTable property change event. */
    firePropertyChange("autoSelectTable", new Boolean(oldValue), new Boolean(autoSelectTable));

    return;
  }

  /**
   * Sets the message property (java.lang.String) value.
   * @param message The new value for the property.
   * @see #getMessage
   */
  public void setMessage(String message) {
    /* Get the old property value for fire property change event. */
    String oldValue = fieldMessage;

    /* Set the message property (attribute) to the new value. */
    fieldMessage = message;

    /* Fire (signal/notify) the message property change event. */
    firePropertyChange("message", null, message);

    return;
  }

  /**
   * Sets the selectedProject property (org.dbgen.Project) value.
   * @param selectedProject The new value for the property.
   * @see #getSelectedProject
   */
  public void setSelectedProject(Project selectedProject) {
    /* Get the old property value for fire property change event. */
    Project oldValue = fieldSelectedProject;

    /* Set the selectedProject property (attribute) to the new value. */
    fieldSelectedProject = selectedProject;

    /* Fire (signal/notify) the selectedProject property change event. */
    /* XXX - the following must pass null so that it always make notification */
    firePropertyChange("selectedProject", null, selectedProject);

    return;
  }

  /**
   * Sets the selectedTable property (org.dbgen.Table) value.
   * @param selectedTable The new value for the property.
   * @see #getSelectedTable
   */
  public void setSelectedTable(Table selectedTable) {
    /* Get the old property value for fire property change event. */
    Table oldValue = fieldSelectedTable;

    /* Set the selectedTable property (attribute) to the new value. */
    fieldSelectedTable = selectedTable;

    /* Fire (signal/notify) the selectedTable property change event. */
    /* XXX - the following must pass null so that it always make notification */
    firePropertyChange("selectedTable", null, selectedTable);

    return;
  }

  /**
   * Sets the workbench property (org.dbgen.Workbench) value.
   * @param workbench The new value for the property.
   * @see #getWorkbench
   */
  public void setWorkbench(Workbench workbench) {
    /* Get the old property value for fire property change event. */
    Workbench oldValue = fieldWorkbench;

    /* Set the workbench property (attribute) to the new value. */
    fieldWorkbench = workbench;

    /* Fire (signal/notify) the workbench property change event. */
    firePropertyChange("workbench", oldValue, workbench);

    /* Create the tree nodes recursively now */
    createTree();

    /* Listen to ProjectChange event */
    workbench.addProjectChangedListener(this);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event org.dbgen.TableAddedEvent
   */
  public void tableAdded(TableAddedEvent event) {

    ProjectTreeNode parent = findSelectedProjectNode();
    Table newTable = event.getTable();
    TableTreeNode tableNode = new TableTreeNode(newTable);

    /* Find out where to insert the node */
    Vector tables = parent.getProject().getTables();
    int index = Util.findObjectFromVector(newTable, tables);

    if (parent != null)
    {
      parent.insert(tableNode, index);
    }

    DefaultTreeModel tm = (DefaultTreeModel) getModel();
    tm.nodesWereInserted(parent, new int[] { index });

    //reload(parent);

    TreePath path = new TreePath(new Object[] { root, parent, tableNode });

    if (getAutoSelectTable()) {
      setSelectionPath(path);
    } else {
      makeVisible(path);
    }

    /* Listen to property change of the table so we can update representation */
    newTable.addPropertyChangeListener(this);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event org.dbgen.TableDeletedEvent
   */
  public void tableDeleted(TableDeletedEvent event) {

    TableTreeNode tableNode = findSelectedTableNode();
    TableTreeNode nextNode = (TableTreeNode) tableNode.getNextSibling();
    ProjectTreeNode parent = (ProjectTreeNode) tableNode.getParent();
    int index = parent.getIndex(tableNode);
    int count = parent.getChildCount();
    int newIndex = (index == count-1) ? index-1 : index;

    /* Remove the table node */
    parent.remove(tableNode);

    /* Notify Jtree about the removal */
    DefaultTreeModel tm = (DefaultTreeModel) getModel();
    tm.nodesWereRemoved(parent, new int[] { index }, new Object[] { event.getTable() });

    //reload(parent);

    /* Select next table node */
    if (newIndex >= 0)
      selectTable(parent, (TableTreeNode) parent.getChildAt(newIndex));
    else
      selectProject(parent);

    return;
  }

  /**
   * Testing only.
   * @param args java.lang.String[]
   */
  public static void test(String args[]) {

    JFrame frame = new JFrame("Workbench Tree View Testing");
    WorkbenchTreeView view = new WorkbenchTreeView();
    view.setWorkbench(Workbench.getTestWorkbench());
    frame.getContentPane().add(view);
    frame.pack();
    frame.setVisible(true);

    return;
  }

  /**
   * This method was created by a SmartGuide.
   * @param event javax.swing.event.TreeSelectionEvent
   */
  public void valueChanged(TreeSelectionEvent event) {

    int level = getSelectionLevel();

    switch (level)
    {
    case 2:
      setSelectedProject(findSelectedProjectNode().getProject());
    break;

    case 3:
      setSelectedProject(findSelectedProjectNode().getProject());
      setSelectedTable(findSelectedTableNode().getTable());
    break;
    default:
    break;

      //throw new RuntimeException("WorkbenchTreeView.valueChanged() incorrect: level = " + level);
    }
  }
}
